﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Example_MatchDays
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // ----
            this.dateTimePicker_StartDate.Value = new DateTime(2000, 1, 1);
            this.dateTimePicker_EndDate.Value = new DateTime(2099, 12, 31);
        }

        // --------
        private void button_MatchDays_Click(object sender, EventArgs e)
        {
            DayOfWeek dayOfWeek = (DayOfWeek)this.comboBox_DayOfWeek.SelectedIndex;
            int month = this.comboBox_Month.SelectedIndex + 1;
            int day = this.comboBox_Day.SelectedIndex + 1;
            DateTime startDate = this.dateTimePicker_StartDate.Value;
            DateTime endDate = this.dateTimePicker_EndDate.Value;
            // ----
            this.WriteMatchDays(dayOfWeek, month, day, startDate, endDate);
        }

        // --------
        private void WriteMatchDays(
            DayOfWeek dayOfWeek,	// -- マッチ条件の曜日
            int month,		        // -- マッチ条件の月
            int day,			    // -- マッチ条件の日
            DateTime startDate,	    // -- 対象期間の開始日
            DateTime endDate)	    // -- 対象期間の終了日
        {
            this.textBox_MatchDays.Clear();
            // ----
            int count = 0;
            DateTime date = startDate;
            while (date <= endDate)
            {
                if (date.DayOfWeek == dayOfWeek &&
                    date.Month == month && date.Day == day)
                {
                    // ---- マッチ！
                    count++;
                    this.textBox_MatchDays.Text += string.Format("（{0}）{1}\r\n",
                        count.ToString().PadLeft(2), date.ToString("d"));
                }
                date = date.AddDays(1);
            }
        }
    }
}
