﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Example_MusicAlbum
{
    struct Music
    {
        // -------- ①コンストラクタ
        public Music(string title, string artist, MusicGenreEnum musicGenre, double playingTime)
        {
            m_title = title;
            m_artist = artist;
            m_musicGenre = musicGenre;
            m_playingTime = playingTime;
        }
        public Music(string title, string artist)
            : this(title, artist, MusicGenreEnum.Unknown, 0){   }
        // -------- ②フィールド
        private string m_title;                 // -- タイトル
        private string m_artist;                // -- アーチスト
        private MusicGenreEnum m_musicGenre;    // -- ジャンル
        private double m_playingTime;           // -- プレイ時間（分.秒）
        // -------- ③プロパティ
        public string Title { get { return m_title; } }
        public string Artist{   get { return m_artist; }}
        public MusicGenreEnum MusicGenre
        {
            get { return m_musicGenre; }
            set { m_musicGenre = value; }
        }
        public double PlayingTime
        {
            get { return m_playingTime; }
            set { m_playingTime = value; }
        }
        public int PlayingSeconds
        {
            get
            {
                int minits100 = (int)(this.PlayingTime * 100);
                int playingSeconds = (minits100 / 100 * c_minuteSeconds) + (minits100 % 100);
                return playingSeconds;
            }
        }
        // -------- ④定数
        private const int c_minuteSeconds = 60;
        private const string c_minutesModification = "分";
        private const string c_secondsModification = "秒";
        // -------- ⑤メソッド
        public string ReportMusic()
        {
            string reportMusic = this.Title + "(" + this.Artist + ")";
            int playingSeconds = this.PlayingSeconds;
            reportMusic += ((playingSeconds / c_minuteSeconds).ToString() + c_minutesModification);
            reportMusic += ((playingSeconds % c_minuteSeconds).ToString() + c_secondsModification);
            return reportMusic;
        }
    }
}
