﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example_MusicAlbum
{
    class Program
    {
        static void Main(string[] args)
        {
            const string c_artist = "Bill Evans Trio";
            Music[] musics = new Music[]
            {
                new Music("My Foolish Heart", c_artist, MusicGenreEnum.Jazz, 4.59),
                new Music("My Romance", c_artist, MusicGenreEnum.Jazz, 7.12),
                new Music("Some Other Time", c_artist, MusicGenreEnum.Jazz, 4.58),
                new Music("Milestones", c_artist, MusicGenreEnum.Jazz, 6.31),
            };
            MusicAlbum musicAlbum = new MusicAlbum("My Foolish Heart", c_artist, musics);
            // ----
            Program.ReportMusicAlbum(musicAlbum);
            // ----
            Console.ReadLine();
        }

        // --------
        private static void ReportMusicAlbum(MusicAlbum musicAlbum)
        {
            MusicAlbum.CheckMusicDelegate checkMusicDelegate = new MusicAlbum.CheckMusicDelegate(Program.CheckMusic);
            musicAlbum.CheckAlbum(checkMusicDelegate);

            // ----
            string palyingTime = musicAlbum.PlayingTime;
            // ----
            string traceLine = "MusicAlbum.PalyingTime:" + palyingTime;
            Console.WriteLine(traceLine);

            // ----
            string reportMusic = musicAlbum[0].ReportMusic();
            // ----
            traceLine = "MusicAlbum.ReportMusic:" + reportMusic;
            Console.WriteLine(traceLine);
        }
        // --------
        private static bool CheckMusic(int musicIndex, Music music)
        {
            string traceLine = "MusicAlbum.CheckMusic:" + musicIndex.ToString();
            traceLine += (music.Title + "/" + music.Artist);
            Console.WriteLine(traceLine);

            bool isBreak = (music.Title.IndexOf("Time") >= 0);
            return isBreak;
        }


    }
}
