﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
// --------
using System.IO;
// --------
namespace Example_Operator
{
    class Program
    {
        static void Main(string[] args)
        {
            // ---- （９）演算子を理解しよう（１）
            DayOfWeek dayOfWeek = DayOfWeek.Sunday;
            int month = 1;
            int day = 1;
            DateTime startDate = new DateTime(2000, 1, 1);
            DateTime endDate = startDate.AddYears(100);
            // ----
            Program.WriteMatchDays(dayOfWeek, month, day, startDate, endDate);

            // ---- （10）演算子を理解しよう（２）
            //-Bar bar = new Bar(-1.0d, 1.0d, 50);
            // ----
            double _2piRad = Math.PI * 2;   // -- 360度
            int division = 24;              // -- 24分割
            double divisionRad = _2piRad / division;
            // ----
            double rad = 0;
            int index = 0;
            while (index <= division)
            {
                double sin = Math.Sin(rad);
                // ----
                string barLine = Program.GetBarLine(-1.0d, 1.0d, 50, sin, '+');
                //-string barLine = bar.GetLine(sin, '+');
                // ----
                double angle = index * 360 / division;
                Console.WriteLine("sin({0}°) {1} ({2})", angle.ToString().PadLeft(3), barLine, sin.ToString("n3"));
                // ----
                rad += divisionRad;
                index++;
            }

#if false
            // ---- 論理演算子
            string path = "..\\..\\Program.cs";
            // ----
            string hitLines = Program.GetHitLines(path, "int", "doiuble", "string", false);
            Console.WriteLine("■{0}で「int」「doiuble」「string」のどれかがある行\n--------\n{1}--------", path, hitLines);
            // ----
            hitLines = Program.GetHitLines(path, ".", ",", ";", true);
            Console.WriteLine("■{0}で「.」「,」「;」のどれもある行\n--------\n{1}--------", path, hitLines);
#endif

            // ----
            Console.ReadLine();
        }

        // --------（10）演算子を理解しよう（２）
        static string GetBarLine(double minValue, double maxValue, int maxBarLength, double value, char mark)
        {
            double rate = (value - minValue) / (maxValue - minValue);
            int barLength = (int)(maxBarLength * rate);
            // ----
            string barLine = string.Empty;
            int index = 0;
            while (index < barLength)
            {
                barLine += "-";
                index++;
            }
            barLine += mark;
            return barLine;
        }

        // -------- （９）演算子を理解しよう（１）
        static void WriteMatchDays(DayOfWeek dayOfWeek, int month, int day, DateTime startDate, DateTime endDate)
        {
            Console.WriteLine("{0}の{1}月{2}日",
                dayOfWeek.ToString(), month, day);
            // ----
            Console.WriteLine("{0}～{1}",
                startDate.ToString("d"), endDate.ToString("d"));
            // ----
            int count = 0;
            DateTime date = startDate;
            while (date <= endDate)
            {
                if (date.DayOfWeek == dayOfWeek &&
                    date.Month == month && date.Day == day)
                {
                    // ---- マッチ！
                    count++;
                    Console.WriteLine("（{0}）{1}",
                        count.ToString().PadLeft(2), date.ToString("d"));
                }
                date = date.AddDays(1);
            }
        }
        // -------- 論理演算子
        static string GetHitLines(string path, string word1, string word2, string word3, bool isAnd)
        {
            string hitLines = null;
            // ----
            StreamReader streamReader = File.OpenText(path);
            // ----
            string text = streamReader.ReadLine();
            while (text != null)
            {
                bool isHit1 = text.IndexOf(word1) >= 0;
                bool isHit2 = text.IndexOf(word2) >= 0;
                bool isHit3 = text.IndexOf(word3) >= 0;
                // ----
                bool isHit = false;
                if (isAnd)
                {
                    // ---- AND
                    isHit = isHit1 & isHit2 & isHit3;
                }
                else
                {
                    // ---- OR
                    isHit = isHit1 | isHit2 | isHit3;
                }
                // ----
                if (isHit)
                {
                    char[] trimChars = new char[] { ' ', '\t' };
                    hitLines += (text.TrimStart(trimChars) + "\n");
                }
                // ----
                text = streamReader.ReadLine();
            }
            streamReader.Close();
            // ----
            return hitLines;
        }
    }
}
